#include <stdio.h>
#include <unistd.h>
#define _GNU_SOURCE
#include <string.h>
#include "mpi.h"

#define MAX_LINE 600
#define MAX_HOSTNAME 100

char *estados[2] = {
    "AMAZONAS",
    "RIO GRANDE DO SUL"
};
void exibe_maior();
double soma(char *estado);

int main(int argc, char **argv) {
    int nodes; /* Quantos nós no total */
    int id;    /* Identificação do nó (único) */
    char hostname[MAX_HOSTNAME];
    double total;

    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &nodes);
    MPI_Comm_rank(MPI_COMM_WORLD, &id);

    gethostname(hostname, MAX_HOSTNAME);
    printf("INFO: %d = %s\n", id, hostname);

    if (id == 0)
        exibe_maior();
    else {
        total = soma(estados[id - 1]);
        printf("INFO: %d calculou %s\n", id, estados[id - 1]);
        /* int MPI_Send(void* message, int count, MPI_Datatype, int dest,
           int tag, MPI_Comm) */
        MPI_Send(&total, 1, MPI_DOUBLE, 0, 0, MPI_COMM_WORLD);
    }

    MPI_Finalize();
    return 0;
}

void exibe_maior() {
    double total;
    double totalMax = 0.00;
    int i;
    int iMax = 1; 
    MPI_Status status; /* Status do recebimento */

    for (i = 0; i < 2; i++) {
        /* int MPI_Recv(void* message, int count, MPI_Datatype, int source, int tag,
           MPI_Comm, MPI_Status*) */
        MPI_Recv(&total, 1, MPI_DOUBLE, i+1, 0, MPI_COMM_WORLD, &status);
        printf("INFO: Recebi total de %s (%d) = R$ %.2f\n",
                estados[i], i+1, total);
        /* Atualiza o maior valor */
        if (total > totalMax) {
            totalMax = total;
            iMax = i;
        }
    }

    printf("O estado que mais gastou foi %s: R$ %.2f\n", estados[iMax], total);
}

double soma(char *estado) {
    FILE *fp;
    char linha[MAX_LINE];
    char *campo_valor;
    double soma = 0.00;

    int ret, inteiro, decimal;
    char *p;
    
    fp = fopen("2008-estado.csv", "r");

    /* pulando a primeira linha (cabeçalho) */
    fgets(linha, MAX_LINE, fp);

    while ( (p = fgets(linha, MAX_LINE, fp)) != NULL ) {
        if (strstr(linha, estado) == NULL)
            continue;
        campo_valor = strrchr(linha, ';');
        ret = sscanf(campo_valor, ";%d,%d\n", &inteiro, &decimal);
        if (ret > 0)
            soma += inteiro;
        if (ret == 2) {
            if (decimal < 10)
                soma += decimal/10.0;
            else
                soma += decimal/100.0;
        }
    }
    fclose(fp);

    return soma;
}
