#!/usr/bin/perl -w
use strict;
use utf8;

# O programa recebe como argumento o nome do estado
my $nARGV = @ARGV;
if ($nARGV < 1) {
    print "Informe o nome do estado. Exemplo: $0 Bahia\n";
    exit;
}
my $estado = join(' ', @ARGV);
my $soma = 0;

# seleciona a coluna 11 (valor) das linhas que iniciam com o nome do estado
open FILE, "grep -i '^\"$estado\";' 2008-estado.csv | cut -d';' -f 11 |" or die $!;

# processa cada linha separadamente
while (<FILE>) {
    chomp;       # Remove a quebra de linha do final
    s/,/./;      # Troca , por . para somar corretamente
    $soma += $_; # Atualiza a soma
}

close (FILE);

# Formata o número para ficar mais legível
1 while $soma =~ s/(\d+)((\d{3})(\.|$))/$1.$2/;
$soma .= ',00' if not $soma =~ s/(.+)\.(\d\d?$)/$1,$2/;

print "$estado gastou R\$ $soma\n";
print 'Calculado por '.`hostname`;
